package com.displaytime;

import java.text.SimpleDateFormat;
import java.util.Date;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.widget.TextView;

public class DisplayTime extends Activity {
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        updateTime();
        
		handler.removeCallbacks(updateTimeTask);
		handler.postDelayed(updateTimeTask, 1000);	        
    }
    
	private Runnable updateTimeTask = new Runnable() {
		public void run() {
			updateTime();
			handler.postDelayed(this, 1000);
		}
	};
	
	private void updateTime() {
		final TextView time = (TextView) findViewById(R.id.time);			
		final Date currentTime = new Date( System.currentTimeMillis() );
		final SimpleDateFormat formatterTime = new SimpleDateFormat( "H:mm:ss" );
		time.setText( formatterTime.format(currentTime) );
	}
	
	@Override
	protected void onStop() {
		super.onStop();
		handler.removeCallbacks(updateTimeTask);
	}
	
    @Override
    protected void onResume() {
        super.onResume();
		handler.removeCallbacks(updateTimeTask);
		handler.postDelayed(updateTimeTask, 1000);
    }
    
	@Override
	protected void onDestroy() {
		super.onDestroy();
    	if ( handler != null )
    		handler.removeCallbacks(updateTimeTask);
    	handler = null;		
	}
    
    private Handler handler = new Handler();
}